<?php
/**************************************************
	GOOGLETAGGED MOD V1.2 - GoogleTagged.php
**************************************************/
if (!defined('SMF'))
	die('Hacking attempt...');

function GoogleTagged() {

	// LOAD THE TEMPLATE AND LANGUAGE FILES
	loadtemplate('GoogleTagged');
	loadLanguage('GoogleTagged');

	// WHAT DO YOU WANT TO DO TODAY?
	if (isset($_REQUEST['sa']) && $_REQUEST['sa'] == 'admin') {
		// CHECK PERMISSION TO MANAGE BEFORE ALLOWING THEM TO SEE THE AREA
		// OR DO ADMIN FUNCTIONS THAT WILL FOLLOW
		isAllowedTo('googletagged_manage');
		// OK, THEY HAVE THE PERMISSION, TAKE ME TO YOUR ADMIN AREA
		ShowGoogleTaggedAdmin();
		
	} else {
		// CALL THE FUNCTION TO SHOW THE TAGGED TOPICS
		ShowGoogleTaggedTopics();
	}

}
function ShowGoogleTaggedTopics()
{
	// GLOBALS TO USE
	global $scripturl, $user_info, $context, $txt, $mbname, $db_prefix;
	global $ID_MEMBER, $modSettings, $settings, $board, $sourcedir;
	
	// TO TELL US WHEN WE ARE DONE!
	$done = false;
	
	// DO WE HAVE A TAG ID?
	if (!empty($_REQUEST['id'])) {
		
		// MAKE IT SAFE
		$idtag = (int) $_REQUEST['id'];
		$_REQUEST['start'] = (int) $_REQUEST['start'];
		
		// QUERY THE ID_TAG TO GET THE TAG NAME
		$query = db_query("
			SELECT tag
			FROM {$db_prefix}googletagged
			WHERE ID_TAG = $idtag
			LIMIT 1
		", __FILE__, __LINE__);
		
		// FOUND THE TAG?
		if (mysql_num_rows($query) != 0) {
			$row = mysql_fetch_assoc($query);
			// GET THE TAG
			$context['googletagged_tag'] = $row['tag'];
			$context['googletagged_text'] = str_replace("+", "", $row['tag']);
			// TIDY UP
			unset($row);
			mysql_free_result($query);
			
			// FORM THE PAGE TITLE WITH OUR SEARCH
			$context['page_title'] = $mbname .' - '. $txt['googletagged_search'] . $context['googletagged_text'];
			$context['linktree'][] = array(
					'url' => $scripturl . '?action=tagged',
					'name' => $txt['googletagged_search'] .'"'. $context['googletagged_text'].'"'
			);
		
			// LOAD THE ICONS TO USE IN A BIT
			$default_icons = array(
								'xx', 'thumbup', 'thumbdown', 'exclamation', 'question', 'lamp', 'smiley',
								'angry', 'cheesy', 'grin', 'sad', 'wink', 'moved', 'recycled', 'wireless'
							);
			$context['icon_sources'] = array();
			foreach ($default_icons as $icon) {
				$context['icon_sources'][$icon] = 'images_url';
			}
			// ARRAY FOR SORTING - DEFAULT = HITS
			$sort_methods = array(
				'subject' => 'ms.subject',
				'starter' => 'ms.posterName',
				'replies' => 't.numReplies',
				'views' => 't.numViews',
				'first_post' => 't.ID_TOPIC',
				'last_post' => 't.ID_LAST_MSG',
				'hits' => 'g.hits',
			);

			// WORK OUT SORT METHOD
			if (!isset($_REQUEST['sort']) || !isset($sort_methods[$_REQUEST['sort']])) {
				$context['sort_by'] = 'hits';
				$_REQUEST['sort'] = 'g.hits';
				$ascending = isset($_REQUEST['asc']);
				$context['querystring_sort_limits'] = $ascending ? ';asc' : '';
			} else {
				$context['sort_by'] = $_REQUEST['sort'];
				$_REQUEST['sort'] = $sort_methods[$_REQUEST['sort']];
				$ascending = !isset($_REQUEST['desc']);
				$context['querystring_sort_limits'] = ';sort=' . $context['sort_by'] . ($ascending ? '' : ';desc');
			}
			$context['sort_direction'] = $ascending ? 'up' : 'down';
			
			// GET READY FOR PAGINATION
			$query = db_query("
				SELECT COUNT(DISTINCT t.ID_TOPIC)
				FROM {$db_prefix}topics AS t, {$db_prefix}googletagged as g
				WHERE tag = '". $context['googletagged_tag'] ."'
					AND g.status != 0
					AND g.ID_TOPIC = t.ID_TOPIC
			", __FILE__, __LINE__);
			list ($num_topics) = mysql_fetch_row($query);
			$context['page_index'] = constructPageIndex($scripturl . '?action=tagged;id='. $idtag .';tag='. $context['googletagged_tag'], $_REQUEST['start'], $num_topics, $modSettings['defaultMaxTopics']);
			$context['easy_sort'] = $scripturl . '?action=tagged;id='. $idtag .';tag='. $context['googletagged_tag'].';';
			$context['current_page'] = $_REQUEST['start'] / $modSettings['defaultMaxTopics'];
			// TIDY UP
			mysql_free_result($query);

			// RESULTS
			// SORT INITIALLY BY HITS
			// WHERE TAG HASNT BEEN BANNED
			$query = db_query("
					SELECT g.ID_TAG, g.tag, g.status, g.hits, g.ID_TOPIC, t.ID_FIRST_MSG, t.ID_LAST_MSG, b.name AS bname,
							t.ID_BOARD, t.ID_POLL, t.isSticky, t.locked, t.numReplies, t.numViews,
							ms.ID_MEMBER, ms.ID_TOPIC, ms.posterTime AS firstPosterTime, ms.posterTime, ms.subject AS firstSubject, 
							ms.ID_MEMBER AS ID_FIRST_MEMBER, ms.posterName AS firstPosterName, ml.subject AS lastSubject,
							ms.icon AS firstIcon, ms.smileysEnabled AS firstSmileys,
							ml.ID_MEMBER AS ID_LAST_MEMBER, ml.posterTime AS lastPosterTime, ml.modifiedTime AS lastModifiedTime, 
							ml.ID_TOPIC, ml.subject AS lastSubject, ml.posterName AS lastPosterName, ml.icon AS lastIcon,
							ml.modifiedTime AS lastModifiedTime, ml.smileysEnabled AS lastSmileys
					FROM ({$db_prefix}googletagged as g, {$db_prefix}boards AS b, {$db_prefix}topics as t,
							{$db_prefix}messages AS ms, {$db_prefix}messages AS ml)
					WHERE tag = '". $context['googletagged_tag'] ."'
						AND g.status != 0
						AND b.ID_BOARD = t.ID_BOARD
						AND g.ID_TOPIC = t.ID_TOPIC
						AND ms.ID_MSG = t.ID_FIRST_MSG
						AND ml.ID_MSG = t.ID_LAST_MSG
						AND " . $user_info['query_see_board'] . "
					ORDER BY " . $_REQUEST['sort'] . ($ascending ? '' : ' DESC') . "
					LIMIT $_REQUEST[start], $modSettings[defaultMaxTopics]
			", __FILE__, __LINE__);
			
			
			// PREPARE OUR ARRAY FOR TOPICS
			$context['topics'] = array();
			$topic_ids = array();
			
			// SO DID WE FIND SOME TOPICS GOOGLETAGGED WITH THIS TAG?
			if ($num_topics != 0) {
							
				// CYCLE THROUGH THEM AND DO SOME SORTING, BEFORE ADDING TO ARRAY
				while ($row = mysql_fetch_assoc($query)) {
					
					$topic_ids[] = $row['ID_TOPIC'];
					
					// TOPIC MESSAGES PAGINATION
					$topic_length = $row['numReplies'] + 1;
					if ($topic_length > $modSettings['defaultMaxMessages']) {
						$tmppages = array();
						$tmpa = 1;
						for ($tmpb = 0; $tmpb < $topic_length; $tmpb += $modSettings['defaultMaxMessages']) {
							$tmppages[] = '<a href="' . $scripturl . '?topic=' . $row['ID_TOPIC'] . '.' . $tmpb . ';topicseen">' . $tmpa . '</a>';
							$tmpa++;
						}
						// SHOW ALL PAGES?
						if (count($tmppages) <= 5) {
							$pages = ' ' . implode(' ', $tmppages);
							// HIDE SOME
						} else {
							$pages = ' ' . $tmppages[0] . ' ' . $tmppages[1] . ' ... ' . $tmppages[count($tmppages) - 2] . ' ' . $tmppages[count($tmppages) - 1];
							if (!empty($modSettings['enableAllMessages']) && $topic_length < $modSettings['enableAllMessages'])
								$pages .= ' &nbsp;<a href="' . $scripturl . '?topic=' . $row['ID_TOPIC'] . '.0;all">' . $txt[190] . '</a>';
								$pages .= ' ';
						}
					}else	{
						$pages = '';
					}	

					$topicEditedTime = $row['lastPosterTime'] > $row['lastModifiedTime'] ? $row['lastPosterTime'] : $row['lastModifiedTime'];

					// And build the array.
					$context['topics'][$row['ID_TOPIC']] = array(
						'id' => $row['ID_TOPIC'],
						'first_post' => array(
							'member' => array(
							'name' => $row['firstPosterName'],
							'id' => $row['ID_FIRST_MEMBER'],
							'href' => $scripturl . '?action=profile;u=' . $row['ID_FIRST_MEMBER'],
							'link' => !empty($row['ID_FIRST_MEMBER']) ? '<a href="' . $scripturl . '?action=profile;u=' . $row['ID_FIRST_MEMBER'] . '" title="' . $txt[92] . ' ' . $row['firstPosterName'] . '">' . $row['firstPosterName'] . '</a>' : $row['firstPosterName']
							),
							'time' => timeformat($row['firstPosterTime']),
							'timestamp' => $row['firstPosterTime'],
							'subject' => $row['firstSubject'],
							'icon' => $row['firstIcon'],
							'icon_url' => $settings[$context['icon_sources'][$row['firstIcon']]] . '/post/' . $row['firstIcon'] . '.gif',
							'href' => $scripturl . '?topic=' . $row['ID_TOPIC'] . '.0;topicseen',
							'link' => '<a href="' . $scripturl . '?topic=' . $row['ID_TOPIC'] . '.0;topicseen"><b>' . $row['firstSubject'] . '</b></a>'
						),
						'last_post' => array(
							'member' => array(
								'name' => $row['lastPosterName'],
								'id' => $row['ID_LAST_MEMBER'],
								'href' => $scripturl . '?action=profile;u=' . $row['ID_LAST_MEMBER'],
								'link' => !empty($row['ID_LAST_MEMBER']) ? '<a href="' . $scripturl . '?action=profile;u=' . $row['ID_LAST_MEMBER'] . '">' . $row['lastPosterName'] . '</a>' : $row['lastPosterName']
							),
							'time' => timeformat($row['lastPosterTime']),
							'timestamp' => $row['lastPosterTime'],

							'href' => $scripturl . '?topic=' . $row['ID_TOPIC'] . '.0;topicseen#new',
							'link' => '<a href="' . $scripturl . '?topic=' . $row['ID_TOPIC'] . '.0;topicseen#new">' . $row['lastSubject'] . '</a>'
						),
						'href' => $scripturl . '?topic=' . $row['ID_TOPIC'] . '.0;topicseen#new',
						'link' => '<a href="' . $scripturl . '?topic=' . $row['ID_TOPIC'] . '.0;topicseen#new"><b>' . $row['firstSubject'] . '</b></a>',
						'is_sticky' => !empty($modSettings['enableStickyTopics']) && !empty($row['isSticky']),
						'is_locked' => !empty($row['locked']),
						'is_poll' => $modSettings['pollMode'] == '1' && $row['ID_POLL'] > 0,
						'is_hot' => $row['numReplies'] >= $modSettings['hotTopicPosts'],
						'is_very_hot' => $row['numReplies'] >= $modSettings['hotTopicVeryPosts'],
						'is_posted_in' => false,
						'icon' => $row['firstIcon'],
						'subject' => $row['firstSubject'],
						'pages' => $pages,
						'replies' => $row['numReplies'],
						'views' => $row['numViews'],
						'board' => array(
							'id' => $row['ID_BOARD'],
							'name' => $row['bname'],
							'href' => $scripturl . '?board=' . $row['ID_BOARD'],
							'link' => '<a href="' . $scripturl . '?board=' . $row['ID_BOARD'] . '">' . $row['bname'] . '</a>'
						)
					);
					determineTopicClass($context['topics'][$row['ID_TOPIC']]);
				}
				// TIDY UP
				mysql_free_result($query);
				
				// SHOW ME WHICH TOPICS I'VE POSTED IN
				if (!empty($modSettings['enableParticipation']) && !empty($topic_ids)) {
				$query = db_query("
					SELECT ID_TOPIC
					FROM {$db_prefix}messages
					WHERE ID_TOPIC IN (" . implode(', ', $topic_ids) . ")
						AND ID_MEMBER = $ID_MEMBER", __FILE__, __LINE__);
					while ($row = mysql_fetch_assoc($query)) {
						if (empty($context['topics'][$row['ID_TOPIC']]['is_posted_in'])) {
							$context['topics'][$row['ID_TOPIC']]['is_posted_in'] = true;
							$context['topics'][$row['ID_TOPIC']]['class'] = 'my_' . $context['topics'][$row['ID_TOPIC']]['class'];
						}
					}
					// TIDY UP
					unset($row);
					mysql_free_result($query);
				}

				$context['topics_to_mark'] = implode('-', $topic_ids);
						
				// NEXT, SHOW THE RESULTS OF OUR SEARCH
				$context['sub_template']	= 'results';
			
				// IF WE DON'T REACH THIS POINT, WE HAVEN'T BEEN SUCCESSFUL, SO IT WILL FALL BACK TO THE 'GENERAL GOOGLETAGGED' BIT
				$done = true;
			}
		}
	}
	
	// EITHER THERE WASNT A ID_TAG OR THERE WAS AN ERROR
	if(!$done) {
		
		// START OFF WITH OUR TAGS
		$context['page_title'] = $mbname . ' - ' . $txt['googletagged'];
		
		// PREPARE A TAG CLOUD
		// NOW THIS IS COMPLEX BECAUSE THE SAME TAG MAY HAVE BEEN SAVED MULTIPLE TIMES
		// DELETED TOPICS WHERE TAGS STILL REMAIN WILL BE IGNORED.

		$query = db_query("
				SELECT g.tag, g.ID_TAG, g.hits, g.status, g.ID_TOPIC, t.ID_TOPIC
				FROM {$db_prefix}googletagged as g, {$db_prefix}topics as t
				WHERE g.ID_TOPIC = t.ID_TOPIC
					AND g.status != 0
				GROUP BY g.tag
				ORDER BY RAND()
				LIMIT 50
		", __FILE__, __LINE__);
		
		// FOUND SOME TAGS?
		if(mysql_num_rows($query) != 0) {
			// CREATE AN ARRAY FOR TAGS
			$context['googletagged'] = array();
			// CYCLE THROUGH
			$highest = 1 ;
			$lowest = 999999999999 ; // SO IT FORCES THE FIRST ROW TO BE THE LOWEST
			while($row = mysql_fetch_assoc($query)) {
				// STORE THE INFO FOR LATER ON
				$context['googletagged'][] = $row;
				$highest = ($row['hits'] > $highest) ? $row['hits'] : $highest ;
				$lowest = ($row['hits'] < $lowest) ? $row['hits'] : $lowest ;
			}
			// TIDY UP
			unset($row);
			// WORK OUT THE SIZES FOR US
			// FIRST THE MAX AND MIN SIZES THAT WE CAN USE IN %
			$maxsize = 200;
			$minsize = 100;
			// WHATS THE DIFFERENCE - IF 0, DIVIDING MY ZERO WILL CAUSE AN ERROR
			$diff = ($highest - $lowest == 0) ? 1 : ($highest - $lowest) ;
			// EVENLY STEP THE TAGS
			$steps = ($maxsize - $minsize)/$diff;
			
			// CYCLE THROUGH OUR TAGS
			foreach ($context['googletagged'] as $key => $row) {
				// ADD THE COLUMN FOR SIZE
				
				$context['googletagged'][$key]['size'] = ceil($minsize + ($steps * ($row['hits'] - $lowest)));
				$context['googletagged'][$key]['text'] = str_replace("+", " ", $context['googletagged'][$key]['tag']);
			}
			// TIDY UP
			unset($key,$row,$steps,$highest,$lowest,$maxsize,$minsize);
			mysql_free_result($query);
			
			// SECOND POINT - IF NOT REACHED THE END BY HERE - ERROR!!!
			$done = true;
		}
	}
	
	// SEND AN ERROR
	if(!$done){
		$context['googletagged_errors'] = true;
	}
	
}

// BAN TAG - WILL REMOVE ALL BUT ONE INSTANCE OF THE TAG THROUGHOUT, AND SET ITS STATUS TO 0, SO IT WILL NEVER BE SHOWN AGAIN.
function BanTag($tag) {
	
	// GLOBALS WE REQUIRE
	global $ID_MEMBER, $txt, $db_prefix;
	
	// CHECK PERMISSIONS
	$allowed = allowedTo('googletagged_manage');
	if ($allowed == false) {
		fatal_error($txt['googletagged_error'],false);
	}
	// MAKE LOWERCASE
	$tag = strtolower($tag);
	$tag = eregi('^[-0-9a-z]{3,24}$', $tag) ? $tag : '' ;
	if(!empty($tag)) {
		// GET TAG
		$query = db_query("
					SELECT ID_TAG, tag
					FROM {$db_prefix}googletagged
					WHERE tag = '".$tag."'
					LIMIT 1
				", __FILE__, __LINE__);
	
		// FOUND TAG
		if (mysql_num_rows($query) != 0) {
			// GET THE TAG	
			$row = mysql_fetch_assoc($query);
			$idtag = $row['ID_TAG'];
			// TIDY UP
			unset($row);
			mysql_free_result($query);
		
			// BAN THAT OCCURANCE BY SETTING STATUS = 0 & TOPIC_ID = 0 (THEN IT CAN'T BE RE-ADDED TO ANY TOPIC)
			db_query("
				UPDATE {$db_prefix}googletagged
				SET status = '0', ID_TOPIC = '0'
				WHERE ID_TAG = '".$idtag."'
				LIMIT 1
			", __FILE__, __LINE__);
			
			// DELETE ALL THE REMAINING OCCURANCES
			db_query("
				DELETE FROM {$db_prefix}googletagged
				WHERE tag = '".$tag."'
					AND ID_TAG != '".$idtag."'
					AND ID_TOPIC != '0'
				", __FILE__, __LINE__);
		} else {
		// TAG CURRENTLY DOESNT EXIST, SO INSERT IT
			db_query("
				INSERT INTO {$db_prefix}googletagged
					(ID_TOPIC, tag, hits, status)
				VALUES
					('0', '$tag', '1', '0')
					", __FILE__, __LINE__);		
		}
	}	
}

// UNBAN TAG
function UnBanTag() {
	
	// GLOBALS WE REQUIRE
	global $ID_MEMBER, $txt, $db_prefix;
	
	// CHECK PERMISSIONS
	$allowed = allowedTo('googletagged_manage');
	if ($allowed == false) {
		fatal_error($txt['googletagged_error'],false);
	}
	// MAKE LOWERCASE
	$_REQUEST['id'] = (int) $_REQUEST['id'];
	
	// DELETE ALL THE REMAINING OCCURANCES
	db_query("
		DELETE FROM {$db_prefix}googletagged
		WHERE ID_TAG = '".$_REQUEST['id']."'
	", __FILE__, __LINE__);

}

// RESET TAGS (basically all hits are set to 0)
function ResetTags() {
	
	// GLOBALS WE REQUIRE
	global $ID_MEMBER, $txt, $db_prefix;
	
	// CHECK PERMISSIONS
	$allowed = allowedTo('googletagged_manage');
	if ($allowed == false) {
		fatal_error($txt['googletagged_error'],false);
	}
	
	// RESETS ALL HITS TO 0
	db_query("
		UPDATE {$db_prefix}googletagged
		SET hits = 0
	", __FILE__, __LINE__);
}

// OPTIMIZE TAGS (CHECKS FOR TAGS WHERE TOPICS WERE DELETED, BANNED TAGS WHERE POSSIBLY BAN DIDNT WORK PROPERLY)
function OptimizeTags() {
	
	// GLOBALS WE REQUIRE
	global $ID_MEMBER, $txt, $db_prefix, $context;
	
	// CHECK PERMISSIONS
	$allowed = allowedTo('googletagged_manage');
	if ($allowed == false) {
		fatal_error($txt['googletagged_error'],false);
	}
	// NO BANNED WORDS?
	if(isset($context['googletagged_banned'])) {
		foreach($context['googletagged_banned'] as $ID_TAG => $tag) {
			// DELETE ALL THE REMAINING OCCURANCES
			db_query("
					DELETE FROM {$db_prefix}googletagged
					WHERE tag = '".$tag."'
						AND ID_TAG != '".$ID_TAG."'
			", __FILE__, __LINE__);
		}
	}
	
	// LOAD ALL TAGS FOR EACH TOPIC, GROUPED BY TOPIC
	$query = db_query("
				SELECT ID_TOPIC, ID_TAG, tag
				FROM {$db_prefix}googletagged
				WHERE ID_TOPIC != '0'
				GROUP BY ID_TOPIC
			", __FILE__, __LINE__);
			
	if(mysql_num_rows($query) != 0) {
		// PUT ALL THE TOPIC IDS IN AN ARRAY
		$topic_ids = array();
		while($row = mysql_fetch_assoc($query)) {
				$topic_ids[] = $row['ID_TOPIC'];
		}
		// TIDY UP
		mysql_free_result($query);
		unset($row);
		
		// CYCLE THROUGH THE TOPIC IDS, CHECKING THAT THEY EXIST
		foreach($topic_ids as $topic_id) {
			
			$query = db_query("
				SELECT ID_TOPIC
				FROM {$db_prefix}topics
				WHERE ID_TOPIC = '".$topic_id."'
			", __FILE__, __LINE__);
			// IF NO TOPIC FOUND WITH THAT ID
			if(mysql_num_rows($query) == 0) {
				// SO DELETE ALL TAGS RELATING TO THAT TOPIC
				db_query("
					DELETE FROM {$db_prefix}googletagged
					WHERE ID_TOPIC = '".$topic_id."'
				", __FILE__, __LINE__);
			}
			// TIDY UP
			mysql_free_result($query);
		}
		// TIDY UP
		unset($topic_ids,$topic_id);
	}
}

// THE ADMIN PANEL FOR BANNING TAGS AND SUCH
function ShowGoogleTaggedAdmin()
{
	global $db_prefix, $context, $txt, $mbname, $modSettings;
	
	adminIndex('googletagged_settings');
	// CHECK PERMISSION TO MANAGE
	isAllowedTo('googletagged_manage');
	
	// UNBAN TAG?
	if(isset($_REQUEST['unban'])) {
		UnBanTag();
		// REDIRECT BACK TO THE ADMIN
		redirectexit('action=tagged;sa=admin');
	}
	// RESET TAGS? TO 0 HITS?
	if(isset($_REQUEST['reset'])) {
		ResetTags();
		// REDIRECT BACK TO THE ADMIN
		redirectexit('action=tagged;sa=admin');
	}
	// SAVE GOOGLETAGGED SETTING
	if(isset($_POST['save'])) {
		$googletagged = isset($_POST['googletagged']) ? 1 : 0 ;
		$together = isset($_POST['googletagged_together']) ? 1 : 0 ;
	
		// SAVE THE SETTINGS
		updateSettings(
			array(
				'googletagged' => $googletagged,
				'googletagged_together' => $together,
			)
		);
		
		// BAN EACH WORD IN THE BAN TAG FIELDS
		for($i=1;$i<=4;$i++) {
			if(!empty($_REQUEST['googletagged_addwordban'.$i])) {
				BanTag($_REQUEST['googletagged_addwordban'.$i]);
			}
		}
		
		// AS HAVE SAVED - REDIRECT TO AVOID RESENDING DATA WARNINGS
		redirectexit('action=tagged;sa=admin');
	}
	
	// LOAD ALL THE BANNED TAGS/WORDS
	$query = db_query("
				SELECT ID_TAG, tag, status
				FROM {$db_prefix}googletagged
				WHERE status = 0
			", __FILE__, __LINE__);
	
	// IF WE FOUND SOME TAGS, PUT THEM IN AN ARRAY
	if (mysql_num_rows($query) != 0) {
		$context['googletagged_banned'] = array();
		while($row = mysql_fetch_assoc($query)) {
			$context['googletagged_banned'][$row['ID_TAG']] = $row['tag'];
		}
	}
	//OPTIMIZE TAGS (CHECKS FOR TAGS WITHOUT TOPICS, OR BANNED ONES STILL IN)
	if(isset($_REQUEST['optimize'])) {
		OptimizeTags();
		// REDIRECT BACK TO THE ADMIN
		redirectexit('action=tagged;sa=admin');
	}		
	//	LOAD THE TEMPLATE
	$context['page_title'] = $mbname . ' - ' . $txt['googletagged_admin'];
	$context['sub_template']	= 'ShowGoogleTaggedAdmin';
}
?>