<?php
/**************************************************
  GOOGLETAGGED MOD V1.2 - GoogleTagged.template.php
**************************************************/

function template_main()
{
	global $context, $txt, $scripturl;

	// START THE TABLE
	echo '<table border="0" cellpadding="4" cellspacing="0" align="center" width="80%" class="tborder">
			<tr class="titlebg">
				<td align="center">
					', $txt['googletagged_random50'], '
				</td>
			</tr>
			<tr>
				<td align="center" class="windowbg2">';

	// START OUR TAG CLOUD
	if(isset($context['googletagged'])) {
		$i = 1 ;
		// WRITE OUT OUR TAGS
		foreach($context['googletagged'] as $key => $row) {
			echo '  <a href="', $scripturl , '?action=tagged;id=', $row['ID_TAG'] ,';tag=', $row['tag'] ,'" style="font-size: '.$row['size'].'%;" title="', $row['text'] ,'">', $row['text'] ,'</a>';
			// INCREASE COUNTER UNTIL WE MAY NEED TO BREAK
			// IF DIVISABLE BY 10 - NEW LINE
			echo (($i % 10) == 0) ? '<br/>' : '';
			$i++;
		}
		// TIDY UP
		unset($i,$key,$row);
	} else {
		// NO TAGS, SO TELL THE USER
		echo $txt['googletagged_empty'];
	}

	// END THE TABLE
	echo '	</td>
		</tr>
  	</table>';
}

// RESULTS TEMPLATE
function template_results()
{
	global $context, $scripturl, $txt;

		global $context, $settings, $options, $txt, $scripturl, $modSettings;

	echo '
	<table width="100%" border="0" cellspacing="0" cellpadding="3" align="center">
		<tr>
			<td>', theme_linktree(), '</td>
		</tr>
	</table>
	<table border="0" width="100%" cellpadding="0" cellspacing="0">
		<tr>
			<td class="middletext" valign="middle">' . $txt[139] . ': ' . $context['page_index'] . '</td>
		</tr>
	</table>
	<table border="0" width="100%" cellspacing="0" cellpadding="0" class="bordercolor">
		<tr><td>
			<table border="0" width="100%" cellspacing="1" cellpadding="4" class="bordercolor">
				<tr class="titlebg">';
			// NOW WRITE EACH TOPIC ROW			
			if (!empty($context['topics']))
				// HEADERS  FIRST
				echo '<td width="10%" colspan="2">&nbsp;</td>
					<td><a href="', $context['easy_sort'] ,'sort=subject', $context['sort_by'] == 'subject' && $context['sort_direction'] == 'up' ? ';desc' : '', '">', $txt[70], $context['sort_by'] == 'subject' ? ' <img src="' . $settings['images_url'] . '/sort_' . $context['sort_direction'] . '.gif" alt="" border="0" />' : '', '</a></td>
					<td width="14%"><a href="',  $context['easy_sort'] ,'sort=starter', $context['sort_by'] == 'starter' && $context['sort_direction'] == 'up' ? ';desc' : '', '">', $txt[109], $context['sort_by'] == 'starter' ? ' <img src="' . $settings['images_url'] . '/sort_' . $context['sort_direction'] . '.gif" alt="" border="0" />' : '', '</a></td>
					<td width="4%" align="center"><a href="', $context['easy_sort'] ,'sort=replies', $context['sort_by'] == 'replies' && $context['sort_direction'] == 'up' ? ';desc' : '', '">', $txt[110], $context['sort_by'] == 'replies' ? ' <img src="' . $settings['images_url'] . '/sort_' . $context['sort_direction'] . '.gif" alt="" border="0" />' : '', '</a></td>
					<td width="4%" align="center"><a href="', $context['easy_sort'] ,'sort=views', $context['sort_by'] == 'views' && $context['sort_direction'] == 'up' ? ';desc' : '', '">', $txt[301], $context['sort_by'] == 'views' ? ' <img src="' . $settings['images_url'] . '/sort_' . $context['sort_direction'] . '.gif" alt="" border="0" />' : '', '</a></td>
					<td width="24%"><a href="', $context['easy_sort'] ,'sort=last_post', $context['sort_by'] == 'last_post' && $context['sort_direction'] == 'up' ? ';desc' : '', '">', $txt[111], $context['sort_by'] == 'last_post' ? ' <img src="' . $settings['images_url'] . '/sort_' . $context['sort_direction'] . '.gif" alt="" border="0" />' : '', '</a></td>';
	else
		echo '
					<td width="100%" colspan="7">' . $txt[151] . '</td>';
	echo '
				</tr>';
	
	// WRITE EACH TOPIC
	foreach ($context['topics'] as $topic)
	{
		// LOCKED/STICKIED?
		if (!empty($settings['seperate_sticky_lock']) && strpos($topic['class'], 'sticky') !== false)
			$topic['class'] = substr($topic['class'], 0, strrpos($topic['class'], '_sticky'));
		if (!empty($settings['seperate_sticky_lock']) && strpos($topic['class'], 'locked') !== false)
			$topic['class'] = substr($topic['class'], 0, strrpos($topic['class'], '_locked'));

		// WRITE WRONG
		echo '
				<tr>
					<td class="windowbg2" valign="middle" align="center" width="6%">
						<img src="', $settings['images_url'], '/topic/', $topic['class'], '.gif" alt="" /></td>
					<td class="windowbg2" valign="middle" align="center" width="4%">
						<img src="', $topic['first_post']['icon_url'], '" alt="" align="middle" /></td>
					<td class="windowbg', $topic['is_sticky'] && !empty($settings['seperate_sticky_lock']) ? '3' : '' , '" width="48%" valign="middle">
						' , $topic['is_locked'] && !empty($settings['seperate_sticky_lock']) ? '<img src="' . $settings['images_url'] . '/icons/quick_lock.gif" align="right" alt="" style="margin: 0;" />' : '' , '
						' , $topic['is_sticky'] && !empty($settings['seperate_sticky_lock']) ? '<img src="' . $settings['images_url'] . '/icons/show_sticky.gif" align="right" alt="" style="margin: 0;" />' : '', ' ', $topic['first_post']['link'], ' ';
						
						echo '<span class="smalltext">', $topic['pages'], '
						', $txt['smf88'], ' ', $topic['board']['link'], '</span></td>
					<td class="windowbg2" valign="middle" width="14%">
						', $topic['first_post']['member']['link'], '</td>
					<td class="windowbg" valign="middle" width="4%" align="center">
						', $topic['replies'], '</td>
					<td class="windowbg" valign="middle" width="4%" align="center">
						', $topic['views'], '</td>
					<td class="windowbg2" valign="middle" width="22%">
						<span class="smalltext">
								', $topic['last_post']['time'], '<br />
								', $txt[525], ' ', $topic['last_post']['member']['link'], '
						</span>
					</td>
				</tr>';
	}

	echo '
			</table>
		</td></tr>
	</table>
	<table border="0" width="100%" cellpadding="0" cellspacing="0">
		<tr>
			<td class="middletext" valign="middle">' . $txt[139] . ': ' . $context['page_index'] . '</td>
		</tr>
	</table><br />

	<div class="tborder"><div class="titlebg2">
		<table cellpadding="8" cellspacing="0" width="55%">
			<tr>
				<td align="left" style="padding-top: 2ex;" class="smalltext">', !empty($modSettings['enableParticipation']) ? '
					<img src="' . $settings['images_url'] . '/topic/my_normal_post.gif" alt="" align="middle" /> ' . $txt['participation_caption'] . '<br />' : '', '
					<img src="' . $settings['images_url'] . '/topic/normal_post.gif" alt="" align="middle" /> ' . $txt[457] . '<br />
					<img src="' . $settings['images_url'] . '/topic/hot_post.gif" alt="" align="middle" /> ' . $txt[454] . '<br />
					<img src="' . $settings['images_url'] . '/topic/veryhot_post.gif" alt="" align="middle" /> ' . $txt[455] . '
				</td>
				<td align="left" valign="top" style="padding-top: 2ex;" class="smalltext">
					<img src="' . $settings['images_url'] . '/icons/quick_lock.gif" alt="" align="middle" /> ' . $txt[456] . '<br />' . ($modSettings['enableStickyTopics'] == '1' ? '
					<img src="' . $settings['images_url'] . '/icons/' . (!empty($settings['seperate_sticky_lock']) ? 'quick_sticky' : 'normal_post_sticky') . '.gif" alt="" align="middle" /> ' . $txt['smf96'] . '<br />' : '') . ($modSettings['pollMode'] == '1' ? '
					<img src="' . $settings['images_url'] . '/topic/normal_poll.gif" alt="" align="middle" /> ' . $txt['smf43'] : '') . '
				</td>
			</tr>
		</table>
	</div></div>';

}

function template_ShowGoogleTaggedAdmin()
{
	global $context, $scripturl, $txt, $modSettings;

	echo '<form method="post" action="' . $scripturl . '?action=tagged;sa=admin;save">
			<table border="0" align="center" cellpadding="4" cellspacing="0" width="80%" class="tborder">
				<tr class="titlebg">
					<td colspan="2">' . $txt['googletagged_admin']. '</td>
				</tr>
				<tr class="catbg">
					<td colspan="2">
						<b>' . $txt['googletagged_admin_settings']. '</b>
					</td>
				</tr>
				<tr class="windowbg">
					<td>'. $txt['googletagged_googletagged'] . '</td>
					<td><input type="checkbox" name="googletagged" ', $modSettings['googletagged'] == 1 ? 'checked="checked"' : '' ,'/></td>
				</tr>
				<tr class="windowbg">
					<td>'. $txt['googletagged_together'] . '</td>
					<td><input type="checkbox" name="googletagged_together" ', $modSettings['googletagged_together'] == 1 ? 'checked="checked"' : '' ,'/></td>
				</tr>
				<tr class="windowbg">
					<td></td><td><a href="',$scripturl,'?action=tagged;sa=admin;reset">'. $txt['googletagged_admin_reset'] . '</a> | 
					<a href="',$scripturl,'?action=tagged;sa=admin;optimize">'. $txt['googletagged_admin_optimize'] . '</a></td>
				</tr>
					</table><br/>';
					
			// BAN WORDS ADD/REMOVE TABLE
				echo '<table border="0" align="center" cellpadding="4" cellspacing="0" width="80%" class="tborder">
				<tr class="titlebg">
					<td colspan="4">' . $txt['googletagged_adminsbannedwords']. '</td>
				</tr>
				<tr class="catbg">
					<td colspan="4">
						<b>' . $txt['googletagged_admin_addbannedwords']. '</b>
					</td>
				</tr>
				<tr class="windowbg">
					<td>'. $txt['googletagged_admin_addwordban'] . ' 1</td>
					<td><input type="text" name="googletagged_addwordban1" value=""/></td>
					<td>'. $txt['googletagged_admin_addwordban'] . ' 2</td>
					<td><input type="text" name="googletagged_addwordban2" value=""/></td>
				</tr>
				<tr class="windowbg2">
					<td>'. $txt['googletagged_admin_addwordban'] . ' 3</td>
					<td><input type="text" name="googletagged_addwordban3" value=""/></td>
					<td>'. $txt['googletagged_admin_addwordban'] . ' 4</td>
					<td><input type="text" name="googletagged_addwordban4" value=""/></td>
				</tr>
				<tr class="catbg">
					<td colspan="4">
						<b>' . $txt['googletagged_admin_removebannedwords']. '</b>
					</td>
				</tr>';
			// NOW ADD ALL BANNED WORDS
			if(empty($context['googletagged_banned'])) {
				echo '<tr class="windowbg">
						<td colspan="4">
							' . $txt['googletagged_admin_nobannedwords']. '
						</td>
					</tr>';
			} else {
				// SOME TRICKERY NEEDED TO WORK OUT COLUMNS
				$col = 1;
				$alternate = false ;// to alternate colors
				foreach($context['googletagged_banned'] as $ID_TAG => $tag) {
					echo ($col == 1) ? '<tr>' : '';
					echo '<td class="', $alternate ? 'windowbg' : 'windowbg2' , '">
								<a href="', $scripturl ,'?action=tagged;sa=admin;id=', $ID_TAG ,';tag=', $tag ,';unban">', $tag ,'</a>
							</td>';
					echo ($col == 4) ? '</tr>' : '' ;
					$alternate = !$alternate;
					$col = ($col == 4) ? 1 : $col ;
					$col++;
				}
				// CLOSE THE TABLE PROPERLY
				if($col != 1) {
					echo ($col == 2) ? '<td></td><td></td><td></td></tr>' : '' ;
					echo ($col == 3) ? '<td></td><td></td></tr>' : '<td></td></tr>' ; // if not must be 4
				}
			}
				
				echo '</table><br/>';
					
				echo '<br/><center><span style="text-align:center;">
						<input type="submit" name="save" value="', $txt['save'], '" style="margin: 2px;" />
						<input type="hidden" name="sc" value="' , $context['session_id'] , '" />
				</span></center>	
			</form>';
		
}